; THERMOMETER -50...+50 C	
; AUGUST 2005				

; PB0 => ANODE Ziffer 1						
; PB1 => ANODE Ziffer 2						
; PB2 => ANODE Ziffer 3						
;											
; PC0 => LED (grn)							
; PC5 => Analogeingang	Temperatursensor	
; 											
; PD0 => Display a							
; PD1 => Display b							
; PD2 => Display c							
; PD3 => Display d							
; PD4 => Display e							
; PD5 => Display f							
; PD6 => Display g							
; PD7 => Display DP							
; 											
.include "m8def.inc"

.equ TIMERwert	= 65536-4000 		;(2 hoch 16 minus....)	
.equ adr_DATEN	= 0x0060			; 0x0060 START Adresse 	

.equ VIRTUELLE_MASSE=512			; Massepunkte fr Temperatursensor

.def TEMPERATUR_L	=R2
.def TEMPERATUR_H	=R3

.def VORZEICHEN	 	=R4				; +=0 -="-"				

.def ZIFFER_A		=R5				; 1. Ziffer von rechts	
.def ZIFFER_B		=R6				; 2. Ziffer von rechts	
.def ZIFFER_C		=R7				; 3. Ziffer von rechts	

.def PUNKT			=R8				; 1= bei Ziffer1 ....	
.def HELLIGKEIT		=R9				; 0= dunkel 255=hell	

.def SS				=R10			; Sekunde				
.def MM				=R11			; Minute				
.def HH				=R12			; Stunde				


.def temp 		=R16
.def temp1 		=R17
.def temp2 		=R18	
.def temp3 		=R19
.def temp4 		=R20
.def temp5		=R21
.def temp6 		=R22
.def temp7 		=R23
.def temp8 		=R24
.def temp9 		=R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0				

rjmp RESET      ; Reset Handler                           
reti ;rjmp EXT_INT0   ; IRQ0 Handler                      
reti ;rjmp EXT_INT1   ; IRQ1 Handler                      
reti ;rjmp TIM2_COMP  ; Timer2 Compare Handler            
reti ;rjmp TIM2_OVF   ; Timer2 Overflow Handler           
reti ;rjmp TIM1_CAPT  ; Timer1 Capture Handler            
reti ;rjmp TIM1_COMPA ; Timer1 CompareA Handler           
reti ;rjmp TIM1_COMPB ; Timer1 CompareB Handler           
rjmp TIM1_OVF   	  ; Timer1 Overflow Handler           
reti ;rjmp TIM0_OVF   ; Timer0 Overflow Handler           
reti ;rjmp SPI_STC    ; SPI Transfer Complete Handler     
reti ;rjmp ZEICHEN_EINLESEN ; USART RX Complete Handler         
reti ;rjmp USART_UDRE ; UDR Empty Handler                 
reti ;rjmp USART_TXC  ; USART TX Complete Handler         
reti ;rjmp ADC        ; ADC Conversion Complete Handler   
reti ;rjmp EE_RDY     ; EEPROM Ready Handler              
reti ;rjmp ANA_COMP   ; Analog Comparator Handler         
reti ;rjmp TWSI       ; Two-wire Serial Interface Handler 
reti ;rjmp SPM_RDY    ; Store Program Memory Ready Handler


RESET:                        

; PORT-B initialisieren
	ldi temp, 0b00000111
	out DDRB, temp
; PORT-C initialisieren
	ldi temp, 0b00000001	; 
	out DDRC, temp
; PORT-D initialisieren
	ldi temp, 0b11111111	
	out DDRD, temp
; AUSGNGE setzen
	ldi temp, 0b00000000
	out PORTB, temp
	ldi temp, 0b00000001
	out PORTC, temp
	ldi temp, 0b00000000	
	out PORTD, temp

; STACK initialisieren
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp

;Timer Startwert (ca. 1s)
	ldi temp,HIGH(TIMERWERT)	;HIGH
	out tcnt1H,temp         
	ldi temp,LOW(TIMERWERT)   	;LOW   
	out tcnt1L,temp         
; TIMER Vorteiler 						
;0b00000000 TIMER aus                 	
;0b00000001 CLOCK=TAKTFREQUENZ        	
;0b00000010 CLOCK=TAKTFREQUENZ / 8    	
;0b00000011 CLOCK=TAKTFREQUENZ / 64   	
;0b00000100 CLOCK=TAKTFREQUENZ / 256  	
;0b00000101 CLOCK=TAKTFREQUENZ / 1024 	
;0b00000110 Abfallende Flanke Pin T0  	
;0b00000111 Steigende  Flanke Pin T0  	
	ldi temp,0b00000101           
	out tccr1b,temp          
; TIMER (1s) aktivieren
;Timer1-berlauf-Int aktivieren              
;OCIE2  => 								     
;TOIE2  => Interrupt bei berlauf (TIMER2)   
;TICIE1 => Interrupt bei Capture			 
;OCIE1A => Interrupt bei Erreichen Stand in A
;OCIE1B => Interrupt bei Erreichen Stand in A
;TOIE1  => Interrupt bei berlauf (TIMER1)   
;TOIE0  => Interrupt bei berlauf (TIMER0)   
 	ldi temp,(1<<toie1)
 	out timsk,temp          

; ADC initialisieren mit "Free Run" und Vorteiler 128 
; Bit 7 -ADEN: ADC Enable                             
; Bit 6 -ADSC: ADC Start Conversion                   
; Bit 5 -ADFR: ADC Free Running Select                
; Bit 4 -ADIF: ADC Interrzpt Flag                     
; Bit 3 -ADIE: ADC Interrupt Enable                   
; Bit 2 -ADPS2: Vorteiler                             
; Bit 1 -ADPS2: Vorteiler                             
; Bit 0 -ADPS2: Vorteiler                             
; Vorteiler von 3,5 ms bis 52 us einstellbar          
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)) + 7
	out ADCSR, temp
; ADC initialisieren  ###########################################
; Bit 7 - externe Referenz    							
; Bit 6 - externe Referenz    							
; Bit 5 - left Adjust Result  							
; Bit 4 -                     							
; Bit 3 - KANAL-Wahl          							
; Bit 2 - KANAL-Wahl          							
; Bit 1 - KANAL-Wahl          							
; Bit 0 - KANAL-Wahl          							
	ldi temp, ((0<<REFS1)|(0<<REFS0)|(0<<ADLAR))+5
	out ADMUX, temp

; SRAM lschen												
	ldi YH,high(adr_daten)	; Y-REGISTER  Initialisierung
	ldi YL, low(adr_daten)	; Y-REGISTER  Initialisierung
	ldi temp1,0
	clr temp
SRAM_LOSCHEN_W:	
	st Y+, temp1
	dec temp
	brne SRAM_LOSCHEN_W
  
; Startwerte												
	ldi temp,50
	mov HELLIGKEIT, temp 

	clr TEMPERATUR_L
	clr TEMPERATUR_H	

	clr SS			; SEKUNDEN	
	
	ldi temp,0		; MINUTEN	
	mov MM,temp
	
	ldi temp,21		; STUNDEN	
	mov HH, temp

	clr XL
	clr XH
	clr YL
	clr YH
	clr ZL
	clr ZH

; interrupts freigeben
	sei
;########################################################################
;########################################################################
;########################################################################
LOOP:
	rcall MENUE	

	rcall ANZEIGE_ZIFFER_A
	rcall ANZEIGE_ZIFFER_B
	rcall ANZEIGE_ZIFFER_C
rjmp LOOP
;########################################################################
;########################################################################
;########################################################################
MENUE:
	mov temp, ss
	
	cpi temp,0
	breq MENUE_0

	cpi temp,1
	breq MENUE_0
	
	cpi temp,2
	breq MENUE_0

	cpi temp,3
	breq MENUE_0
	rjmp MENUE_1
	
MENUE_0:	
	rcall ANZEIGE_UHR
	ret
MENUE_1:
	rcall ANZEIGE_TEMPERATUR
ret
;########################################################################
;########################################################################
;########################################################################
ANZEIGE_UHR:
	
	clr PUNKT

	
	mov temp1, HH		
	clr temp2
	rcall FUNKTION_HEX_ASC
	ldi temp, '-'
	mov ZIFFER_A, temp

	mov ZIFFER_B, temp1
	mov ZIFFER_C, temp2
	


	ret
ret
;########################################################################
;########################################################################
;########################################################################
ANZEIGE_TEMPERATUR:
	ldi temp, 2
	mov PUNKT, temp	

	mov temp1, TEMPERATUR_L
	mov temp2, TEMPERATUR_H
	rcall FUNKTION_HEX_ASC
	mov ZIFFER_A, temp1
	mov ZIFFER_B, temp2
; Null-Unterdrckung	
	cpi temp3, '0'	
	brne ANZEIGE_TEMPERATUR_w
	
; Vorzeichen			
	mov ZIFFER_C, VORZEICHEN
	ret
ANZEIGE_TEMPERATUR_w:
	mov ZIFFER_C, temp3

ret
;########################################################################
;########################################################################
;########################################################################
ANZEIGE_ZIFFER_A:
	rcall LED_AUS
	sbi PORTB, 0
	
	
	mov temp, ZIFFER_A	
	rcall FUNKTION_7_SEGMENT
	out PORTD, temp
	
	mov temp, Punkt				; PUNKT ?		
	cpi temp,1	
	brne ANZEIGE_ZIFFER_A_		; nein => SPRUNG
	sbi PORTD,7
ANZEIGE_ZIFFER_A_:
	rcall HELLIGKEITS_STEUERUNG

ret
;########################################################################
;########################################################################
;########################################################################
ANZEIGE_ZIFFER_B:
	rcall LED_AUS
	sbi PORTB, 1
	
	mov temp, ZIFFER_B	
	rcall FUNKTION_7_SEGMENT
	out PORTD, temp

	mov temp, Punkt				; PUNKT ?		
	cpi temp,2	
	brne ANZEIGE_ZIFFER_B_		; nein => SPRUNG
	sbi PORTD,7
ANZEIGE_ZIFFER_B_:
	
	rcall HELLIGKEITS_STEUERUNG

ret
;########################################################################
;########################################################################
;########################################################################
ANZEIGE_ZIFFER_C:
	rcall LED_AUS
	sbi PORTB, 2

	mov temp, 	ZIFFER_C	
	rcall FUNKTION_7_SEGMENT
	out PORTD, temp

	mov temp, Punkt				; PUNKT ?		
	cpi temp,3	
	brne ANZEIGE_ZIFFER_C_		; nein => SPRUNG
	sbi PORTD,7
ANZEIGE_ZIFFER_C_:

	rcall HELLIGKEITS_STEUERUNG

ret
;########################################################################
;########################################################################
;########################################################################
HELLIGKEITS_STEUERUNG:
	ldi temp1,255

HELLIGKEITS_STEUERUNG_w:	
	com temp1
	cp temp1,HELLIGKEIT
	brne HELLIGKEITS_STEUERUNG_ww
	rcall LED_AUS		; aus	
HELLIGKEITS_STEUERUNG_ww:	
	com temp1
	dec	temp1
	brne	HELLIGKEITS_STEUERUNG_w

ret
;########################################################################
;########################################################################
;########################################################################
LED_AUS:
	cbi PORTB, 0
	cbi PORTB, 1
	cbi PORTB, 2
	clr temp
	out PORTD, temp
ret
;########################################################################
;########################################################################
;########################################################################
BERECHNUNG_HELLIGKEIT:
	mov temp, hh	

; > 23 UHR	
	cpi temp, 23
	brsh BERECHNUNG_HELLIGKEIT_DUNKEL
; > 05 UHR	
	cpi temp, 5
	brlo BERECHNUNG_HELLIGKEIT_DUNKEL
	brsh BERECHNUNG_HELLIGKEIT_HELL
BERECHNUNG_HELLIGKEIT_DUNKEL:
	ldi temp,20 
	mov HELLIGKEIT, temp
	ret
BERECHNUNG_HELLIGKEIT_HELL:
	ldi temp,255 
	mov HELLIGKEIT, temp
ret
;########################################################################
;########################################################################
;########################################################################
BERECHNUNG_MITTELWERT:
; Adresse initialisieren		
	ldi YL,  low(adr_DATEN)
	ldi YH, high(adr_daten)

	mov temp1, SS ; SEKUNDE 	
	lsl temp1	  ; SEKUNDE x 2	
	
	clr temp2

; Berechnung der neuen Adresse	
	add YL, temp1
	adc YH, temp2
; WERT SPEICHERN				
	ST Y+,TEMPERATUR_L 	;DATEN SPEICHERN und Zeiger um 1 erhhen	
	ST Y+,TEMPERATUR_H	;DATEN SPEICHERN und Zeiger um 1 erhhen	
; WERT SPEICHERN (den 59. Wert 4 x speichern)				
	ldi temp, 59*2
	brne BERECHNUNG_MITTELWERT_S
	; 60
	ST Y+,TEMPERATUR_L 	;DATEN SPEICHERN und Zeiger um 1 erhhen	
	ST Y+,TEMPERATUR_H	;DATEN SPEICHERN und Zeiger um 1 erhhen	
	; 61
	ST Y+,TEMPERATUR_L 	;DATEN SPEICHERN und Zeiger um 1 erhhen	
	ST Y+,TEMPERATUR_H	;DATEN SPEICHERN und Zeiger um 1 erhhen	
	; 62 
	ST Y+,TEMPERATUR_L 	;DATEN SPEICHERN und Zeiger um 1 erhhen	
	ST Y+,TEMPERATUR_H	;DATEN SPEICHERN und Zeiger um 1 erhhen	
	; 63
	ST Y+,TEMPERATUR_L 	;DATEN SPEICHERN und Zeiger um 1 erhhen	
	ST Y+,TEMPERATUR_H	;DATEN SPEICHERN und Zeiger um 1 erhhen	

; Prfung, ob schon 59. Wert geschrieben wurde
	ldi YL,  low(adr_DATEN+59*2)
	ldi YH, high(adr_daten+59*2)

	LD temp1, Y+   			; DATEN aus SPEICHER laden und Zeiger erhhen
	LD temp2, Y+			; DATEN aus SPEICHER laden und Zeiger erhhen

	tst temp2				; =0 ?		
	brne BERECHNUNG_MITTELWERT_S
	tst temp1				; =0 ?		
	brne BERECHNUNG_MITTELWERT_S
	ret

BERECHNUNG_MITTELWERT_S:
; alle WERTE addieren
	ldi YL,  low(adr_DATEN)
	ldi YH, high(adr_daten)
	clr ZL
	clr ZH

	ldi temp, 64	
BERECHNUNG_MITTELWERT_w:
	LD temp1, Y+   			; DATEN aus SPEICHER laden und Zeiger erhhen
	LD temp2, Y+			; DATEN aus SPEICHER laden und Zeiger erhhen
	
	add ZL, temp1
	adc ZH, temp2
	dec temp
	brne BERECHNUNG_MITTELWERT_w		

	mov temp1, ZL
	mov temp2, ZH

; durch 64 teilen	
	LSR temp2		; :2
	ROR temp1	
	LSR temp2		; :2
	ROR temp1	
	LSR temp2		; :2
	ROR temp1	
	LSR temp2		; :2
	ROR temp1	
	LSR temp2		; :2
	ROR temp1	
	LSR temp2		; :2
	ROR temp1	
	
	mov TEMPERATUR_L, temp1
	mov TEMPERATUR_H, temp2
ret
;########################################################################
;########################################################################
;########################################################################
BERECHNUNG_TEMPERATUR:
	ldi temp1, low(VIRTUELLE_MASSE)
	ldi temp2,high(VIRTUELLE_MASSE)

; Vergleich HIGH-BYTE
	cp TEMPERATUR_H,temp2				; Vergleich	
	brlo BERECHNUNG_TEMPERATUR_KLEINER	; kleiner	
	breq BERECHNUNG_TEMPERATUR_w		; gleich	
	brsh BERECHNUNG_TEMPERATUR_GROESSER	; grer	
; Vergleich LOW-BYTE
BERECHNUNG_TEMPERATUR_w:	
	cp TEMPERATUR_L,temp1				; Vergleich	
	brlo BERECHNUNG_TEMPERATUR_KLEINER	; kleiner	
;ist grer/ gleich	
BERECHNUNG_TEMPERATUR_GROESSER:	
	sub TEMPERATUR_L, temp1
	sbc TEMPERATUR_H, temp2
	clr VORZEICHEN
	ret
;ist kleiner		
BERECHNUNG_TEMPERATUR_KLEINER:
	sub temp1, TEMPERATUR_L
	sbc temp2, TEMPERATUR_H
	mov TEMPERATUR_L, temp1
	mov TEMPERATUR_H, temp2
	ldi temp, '-'	; Vorzeichen
	mov VORZEICHEN, temp
ret
;########################################################################
;########################################################################
;########################################################################
; OUT: 	temp1		
;		temp2		
MESSEN:
; neuen ADC-Wert lesen	; Wert verwerfen, da meist vom vorherigem ADC-Kanal
	sbi ADCSRA, ADIF    ; logisch "1" lscht ADIF flag !
MESSEN_w:                  
	sbis ADCSRA, ADIF
	rjmp MESSEN_w
; neuen ADC-Wert lesen
	sbi ADCSRA, ADIF    ; logisch "1" lscht ADIF flag !
MESSEN_ww:                
	sbis ADCSR, ADIF 
	rjmp MESSEN_ww
; ADC einlesen:
	in TEMPERATUR_L, ADCL 	; immer zuerst low byte lesen
	in TEMPERATUR_H, ADCH 	; danach das mittlerweile gesperrte high byte

	;ldi temp1, low(512+123)
	;mov TEMPERATUR_L,temp1

	;ldi temp2,high(512+123)
	;mov TEMPERATUR_H,temp2

	rcall BERECHNUNG_MITTELWERT
	rcall BERECHNUNG_TEMPERATUR
ret
;########################################################################
;########################################################################
;########################################################################
TIM1_OVF:      
		push TEMP		    ; Sichern von "TEMP" im Stack
		push TEMP1		    ; Sichern von "TEMP" im Stack
		push TEMP2		    ; Sichern von "TEMP" im Stack
		push TEMP3		    ; Sichern von "TEMP" im Stack
		in	 TEMP,SREG		; Einlesen des SREG 
		push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)

		;Timer Startwert 
		ldi temp,HIGH(TIMERWERT)	;HIGH
		out tcnt1H,temp         
		ldi temp,LOW(TIMERWERT)   ;LOW   
		out tcnt1L,temp    
 		; UHR
		cbi   PORTC,0
		rcall UHR		
		rcall LED_AUS
		rcall MESSEN
		rcall BERECHNUNG_HELLIGKEIT

		pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
		out	SREG,TEMP		; Wiederherstellen von SREG
		pop	TEMP			; Wiederherstellen von "TEMP" 
		pop	TEMP3			; Wiederherstellen von "TEMP" 
		pop	TEMP2			; Wiederherstellen von "TEMP" 
		pop	TEMP1			; Wiederherstellen von "TEMP" 
reti                  
;########################################################################
;########################################################################
;########################################################################
UHR:
; Sekunden	
	inc SS
	mov temp, SS
	cpi temp, 60 		; >=60?
	brsh UHR_MM			; ja
	ret
; Minuten	
UHR_MM:
	clr SS
	inc MM
	mov temp, MM
	cpi temp, 60 		; >=60?
	brsh UHR_HH			; ja
	ret
; Stunden
UHR_HH:
	clr MM
	inc HH
	mov temp, HH
	cpi temp, 24 		; >=24?
	brsh UHR_HH_RESET	; ja
	ret
UHR_HH_RESET:
	clr HH
ret
;########################################################################
;########################################################################
;########################################################################
;	Umwandlung z.B.	 FF nach "65535"	(fr Display)		
;	Value: 0...	65.535										
;															
;	input 	temp1	(low)									
;	input 	temp2	(high)									
;															
;	output	temp1	(		   1-er Stelle)					
;	output	temp2	(		  10-er Stelle)					
;	output	temp3	(        100-er Stelle)					
;	output	temp4	(      1.000-er Stelle)					
;	output	temp4	(     10.000-er Stelle)				    
;															
FUNKTION_HEX_ASC:
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, low  (10000)
	sbci temp2, HIGH (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp auf dem Stack sichern            
	subi temp1, low  (-10000)
	sbci temp2, HIGH (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
ret
;########################################################################
;########################################################################
;########################################################################
; UMWANDLUNG von DEZIMAL nach 7 Segment									 
; INPUT:  temp 	
; output: temp	
FUNKTION_7_SEGMENT:
FUNKTION_DEZ_7_SEGMENT_0:
	cpi temp, '0'	
	brne FUNKTION_DEZ_7_SEGMENT_1
	ldi temp, 0b00111111	; 0
FUNKTION_DEZ_7_SEGMENT_1:
	cpi temp, '1'	
	brne FUNKTION_DEZ_7_SEGMENT_2
	ldi temp, 0b00000110	; 1
FUNKTION_DEZ_7_SEGMENT_2:	
	cpi temp, '2'	
	brne FUNKTION_DEZ_7_SEGMENT_3
	ldi temp, 0b01011011	; 2
FUNKTION_DEZ_7_SEGMENT_3:	
	cpi temp, '3'	
	brne FUNKTION_DEZ_7_SEGMENT_4
	ldi temp, 0b01001111	; 3
FUNKTION_DEZ_7_SEGMENT_4:	
	cpi temp, '4'	
	brne FUNKTION_DEZ_7_SEGMENT_5
	ldi temp, 0b01100110	; 4
FUNKTION_DEZ_7_SEGMENT_5:	
	cpi temp, '5'	
	brne FUNKTION_DEZ_7_SEGMENT_6
	ldi temp, 0b01101101	; 5
FUNKTION_DEZ_7_SEGMENT_6:	
	cpi temp, '6'	
	brne FUNKTION_DEZ_7_SEGMENT_7
	ldi temp, 0b01111101	; 6
FUNKTION_DEZ_7_SEGMENT_7:	
	cpi temp, '7'	
	brne FUNKTION_DEZ_7_SEGMENT_8
	ldi temp, 0b00000111	; 7
FUNKTION_DEZ_7_SEGMENT_8:		
	cpi temp, '8'	
	brne FUNKTION_DEZ_7_SEGMENT_9
	ldi temp, 0b01111111	; 8
FUNKTION_DEZ_7_SEGMENT_9:	
	cpi temp, '9'	
	brne FUNKTION_DEZ_7_SEGMENT_s1
	ldi temp, 0b01101111	; 9
FUNKTION_DEZ_7_SEGMENT_s1:	
	cpi temp, '-'	
	brne FUNKTION_DEZ_7_SEGMENT_fertig
	ldi temp, 0b01000000   ; "-"
FUNKTION_DEZ_7_SEGMENT_fertig:

ret
;########################################################################
;########################################################################
;########################################################################
